#pragma once

#include <string>
#include "pieces.h"
#include "moves.h"
#include "evaluation.h"

using std :: string;

//-------------------------------------------------------------------------

class Board
{
public:
	Board();

	void addPiece( int x, int y, int id );
	void addPiece( int x, int y, int color, int type );

	void makeMove( Move move );
	void cancelMove( Move move );

	bool isCheck( int color );
	
	void pasteFen( string fen );
	void parseCastling( string castling );
	void startPos();

	void setCastlingWhite( bool, bool );
	void setCastlingBlack( bool, bool );

	void clear();

	string toFen();
	string toString();

	Piece* whiteKing;
	Piece* blackKing;

	Piece* boardArray[8][8];
private:
};