#include "perfit.h"
#include "game.h"
#include <iostream>

int captures;
int enpassants;
int checks;

int perfit( int depth )
{
	if ( depth == 0 ) return 1;

	list<Move> moves = game.generateMoves();
	int nodes = 0;

	for ( list<Move>::iterator move = moves.begin(); move != moves.end(); move++ )
	{
		game.board.makeMove( *move );

		if ( move -> isEnpassant ) enpassants++;
		if ( move -> captured ) captures++;
		if ( game.board.isCheck( game.turn ) ) checks++; 

		nodes += perfit( depth - 1 );

		game.board.cancelMove( *move );

	}

	return nodes;
}