#pragma once

#include <list>
#include "moves.h"

using std :: list;

//-------------------------------------------------------------------------

class Piece
{
private:
	list<Move> generateKingMoves();
	list<Move> generateQueenMoves();
	list<Move> generateRookMoves();
	list<Move> generateBishopMoves();
	list<Move> generateKnightMoves();
	list<Move> generateBlackPawnMoves();
	list<Move> generateWhitePawnMoves();
public:
	int id;

	int x;
	int y;

	Piece( int id, int x, int y );
	Piece( int color, int type, int x, int y );

	int type();
	int color();

	bool moved; //for kings and rooks only

	list<Move> generateMoves();
	bool isAttacked();

	char toChar();
};