#include "tables.h"

//-------------------------------------------------------------------------

map<int, char> pieceIdToCharTable;
map<char, int> charToPieceIdTable;
map<int, char> intToCharCoordinateX;
map<int, char> intToCharCoordinateY;
map<char, int> charToIntCoordinateX;
map<char, int> charToIntCoordinateY;
map<int, int> pieceIdToValue;

//-------------------------------------------------------------------------

void initiateCharToPieceIdTable()
{
	charToPieceIdTable['P'] = 9;
	charToPieceIdTable['N'] = 10;
	charToPieceIdTable['B'] = 11;
	charToPieceIdTable['R'] = 12;
	charToPieceIdTable['Q'] = 13;
	charToPieceIdTable['K'] = 14;

	charToPieceIdTable['p'] = 17;
	charToPieceIdTable['n'] = 18;
	charToPieceIdTable['b'] = 19;
	charToPieceIdTable['r'] = 20;
	charToPieceIdTable['q'] = 21;
	charToPieceIdTable['k'] = 22;
}

void initiatePieceIdToCharTable()
{
	pieceIdToCharTable[9]  = 'P';
	pieceIdToCharTable[10] = 'N';
	pieceIdToCharTable[11] = 'B';
	pieceIdToCharTable[12] = 'R';
	pieceIdToCharTable[13] = 'Q';
	pieceIdToCharTable[14] = 'K';

	pieceIdToCharTable[17] = 'p';
	pieceIdToCharTable[18] = 'n';
	pieceIdToCharTable[19] = 'b';
	pieceIdToCharTable[20] = 'r';
	pieceIdToCharTable[21] = 'q';
	pieceIdToCharTable[22] = 'k';
}

void initiateIntToCharCoordinateX() 
{
	for ( int x = 0; x <= 7; x++ )
	{
		char xAsChar = x + 'a';
		intToCharCoordinateX[x] = xAsChar;
	}
}

void initiateIntToCharCoordinateY() 
{
	for ( int y = 0; y <= 7; y++ )
	{
		char yAsChar = '8' - y;
		intToCharCoordinateY[y] = yAsChar;
	}
}

void initiateCharToIntCoordinateX() 
{
	for ( int x = 0; x <= 7; x++ )
	{
		char xAsChar = x + 'a';
		charToIntCoordinateX[xAsChar] = x;
	}
}

void initiateCharToIntCoordinateY() 
{
	for ( int y = 0; y <= 7; y++ )
	{
		char yAsChar = '8' - y;
		charToIntCoordinateY[yAsChar] = y;
	}
}

void initiatePieceIdToValue() 
{
	pieceIdToValue[9]  = 1000;
	pieceIdToValue[10] = 3000;
	pieceIdToValue[11] = 3000;
	pieceIdToValue[12] = 5000;
	pieceIdToValue[13] = 9000;
	pieceIdToValue[14] = 0;

	pieceIdToValue[17] = -1000;
	pieceIdToValue[18] = -3000;
	pieceIdToValue[19] = -3000;
	pieceIdToValue[20] = -5000;
	pieceIdToValue[21] = -9000;
	pieceIdToValue[22] = 0;
}

void initiateTables()
{
	initiateCharToPieceIdTable();
	initiatePieceIdToCharTable();
	initiateIntToCharCoordinateX();
	initiateIntToCharCoordinateY();
	initiateCharToIntCoordinateX();
	initiateCharToIntCoordinateY();
	initiatePieceIdToValue();
}